<template>
  <div class="box">
    <div class="boxTop">
      <div class="title">
        <span>园区生产企业总览</span>
        <button style="margin-right: 10%" @click="YQFB()">分布</button>
      </div>
      <div class="topdiv">
        <div class="topBox">
          <div class="topLeft topimg1"></div>
          <div class="topright">
            <div class="topTitle">0</div>
            <div>重大风险</div>
          </div>
        </div>
        <div class="topBox">
          <div class="topLeft topimg2"></div>
          <div class="topright">
            <div class="topTitle">0</div>
            <div>较大风险</div>
          </div>
        </div>
        <div class="topBox">
          <div class="topLeft topimg3"></div>
          <div class="topright">
            <div class="topTitle">0</div>
            <div>一般风险</div>
          </div>
        </div>
        <div class="topBox">
          <div class="topLeft topimg4"></div>
          <div class="topright">
            <div class="topTitle">0</div>
            <div>低风险</div>
          </div>
        </div>
      </div>
    </div>
    <div class="boxCenter">
      <div class="title">
        <span class="centerSpan1"
          >已接入生产企<label>{{ allYQQYZL }}</label
          >家</span
        >
      </div>
      <div class="centerLeft">
        <div id="centerEchart1" class="centerEchart1"></div>
      </div>
      <div class="centerRight" id="centerEchart2"></div>
    </div>
    <div class="boxBottom">
      <div class="title"><span>风险企业排名</span></div>
      <div class="botBox">
        <div id="botttomEchart1" class="bottomLeft"></div>
        <div id="botttomEchart2" class="bottomRight"></div>
      </div>
    </div>
  </div>
</template>

<script>
import { axios_get, axios_post } from "../../../until/request.js";
import Highcharts from "highcharts";
import highcharts3d from "highcharts/highcharts-3d";
export default {
  data() {
    return {
      allYQQYZL: 0,
      fineModelOneShow: false,
    };
  },
  mounted() {
    this.showbotEchart1();
    this.showbotEchart2();
    this.GetYQQYData();

   
  },

  methods: {
    //企业分布
    YQFB() {
       this.$bus.$emit("showQYFB", true);
     
    },
    GetParent(parm) {
      this.$store.commit("savePath", parm);
    },

    GetYQQYData() {
      axios_post("/safe/getCorpGeneralCatalogue").then((response) => {
        this.YQQYZL = response.data;
        var data = [];
        for (let i = 0; i < response.data.length; i++) {
          let obj = {
            name: response.data[i].type,
            value: response.data[i].allCorpNum,
          };
          this.allYQQYZL =
            this.allYQQYZL + parseInt(response.data[i].allCorpNum);

          data.push(obj);
        }

        var len = data.length;
        for (var i = 0; i < len - 1; i++) {
          for (var j = 0; j < len - 1 - i; j++) {
            if (data[j].value < data[j + 1].value) {
              // 相邻元素两两对比
              var temp = data[j + 1]; // 元素交换
              data[j + 1] = data[j];
              data[j] = temp;
            }
          }
        }
        this.showCenEchart1(data);
        this.showCenEchart2(data);
      });
    },
    showbotEchart2() {
      var lineColor1 = [
        "#9999FF",
        "#0066FF",
        "#33FFFF",
        "#33FF00",
        "#FFFF00",
        "#FF9900",
        "#FF3300",
      ];
      var lineColor = [
        "#0254F0",
        "#0254F0",
        "#0254F0",
        "#0254F0",
        "#0254F0",
        "#0254F0",
        "#0254F0",
      ];
      var myChart2 = this.$echarts.init(
        document.getElementById("botttomEchart2")
      );
      var option = {
        tooltip: {
          //item和line搭配，将实现鼠标放置柱条上即可显示提示框，无阴影或者线条
          trigger: "item",
          axisPointer: {
            type: "line",
          },
        },
        grid: {
          left: "1%",
          right: "1%",
          bottom: "1%",
          top: "1%",
          containLabel: true,
        },
        xAxis: [
          {
            type: "value",
            splitLine: {
              //坐标轴在grid区域的分割线
              show: false,
            },
            axisLabel: {
              show: false,
            },
          },
        ],
        yAxis: [
          {
            type: "category",
            data: [
              "企业1",
              "企业2",
              "企业3",
              "企业4",
              "企业5",
              "企业6",
              "企业7",
            ],
            inverse: true, //数组翻转显示
            axisTick: {
              alignWithLabel: true,
              show: false,
            },
            axisLine: {
              show: false,
            },
            axisLabel: {
              textStyle: {
                fontSize: 16,
                color: "#fff",
              },
            },
          },
          {
            type: "category",
            data: [1000, 1000, 1000, 1000, 1000, 1000, 1000],
            inverse: true, //数组翻转显示
            axisTick: {
              alignWithLabel: true,
              show: false,
            },
            axisLine: {
              show: false, //不显示y轴的线
            },
            axisLabel: {
              textStyle: {
                fontSize: 16,
                color: "#fff",
              },
            },
          },
        ],
        series: [
          {
            name: "及格人数",
            type: "bar",
            yAxisIndex: 0,
            data: [10, 52, 20, 33, 39, 80, 50],
            barWidth: "20%", //柱条的宽度
            label: {
              show: true,

              formatter: function (params) {
                //柱条上的文字
                return params.data + "%";
              },
            },
            itemStyle: {
              borderRadius: 5, //圆角
              color: new this.$echarts.graphic.LinearGradient(1, 0, 0, 0, [
                { offset: 0, color: "rgba(50, 229, 255, 1)" },
                { offset: 1, color: "#0254F0" },
              ]),
            },
          },
          {
            name: "",
            type: "bar",
            yAxisIndex: 1, //使两个柱状图重合的效果
            barWidth: "30%",
            data: [100, 100, 100, 100, 100, 100, 100],
            label: {
              show: false,
            },
            itemStyle: {
              color: "none",
              borderColor: "rgba(50, 229, 255, 1)",
              borderWidth: 2,
              borderRadius: 5, //圆角
            },
          },
        ],
      };
      option && myChart2.setOption(option);
    },
    showbotEchart1() {
      var lineColor2 = [
        "#9999FF",
        "#0066FF",
        "#33FFFF",
        "#33FF00",
        "#FFFF00",
        "#FF9900",
        "#FF3300",
      ];
      var lineColor = [
        "#0254F0",
        "#0254F0",
        "#0254F0",
        "#0254F0",
        "#0254F0",
        "#0254F0",
        "#0254F0",
      ];
      var myChart2 = this.$echarts.init(
        document.getElementById("botttomEchart1")
      );
      var option = {
        tooltip: {
          //item和line搭配，将实现鼠标放置柱条上即可显示提示框，无阴影或者线条
          trigger: "item",
          axisPointer: {
            type: "line",
          },
        },
        grid: {
          left: "1%",
          right: "1%",
          bottom: "1%",
          top: "1%",
          containLabel: true,
        },
        xAxis: [
          {
            type: "value",
            splitLine: {
              //坐标轴在grid区域的分割线
              show: false,
            },
            axisLabel: {
              show: false,
            },
          },
        ],
        yAxis: [
          {
            type: "category",
            data: [
              "企业1",
              "企业2",
              "企业3",
              "企业4",
              "企业5",
              "企业6",
              "企业7",
            ],
            inverse: true, //数组翻转显示
            axisTick: {
              alignWithLabel: true,
              show: false,
            },
            axisLine: {
              show: false,
            },
            axisLabel: {
              textStyle: {
                fontSize: 16,
                color: "#fff",
              },
            },
          },
          {
            type: "category",
            data: [1000, 1000, 1000, 1000, 1000, 1000, 1000],
            inverse: true, //数组翻转显示
            axisTick: {
              alignWithLabel: true,
              show: false,
            },
            axisLine: {
              show: false, //不显示y轴的线
            },
            axisLabel: {
              textStyle: {
                fontSize: 16,
                color: "#fff",
              },
            },
          },
        ],
        series: [
          {
            name: "及格人数",
            type: "bar",
            yAxisIndex: 0,
            data: [10, 52, 20, 33, 39, 80, 50],
            barWidth: "20%", //柱条的宽度
            label: {
              show: true,
              formatter: function (params) {
                //柱条上的文字
                return params.data + "%";
              },
            },
            itemStyle: {
              borderRadius: 5, //圆角
              color: new this.$echarts.graphic.LinearGradient(1, 0, 0, 0, [
                { offset: 0, color: "rgba(50, 229, 255, 1)" },
                { offset: 1, color: "#0254F0" },
              ]),
            },
          },
          {
            name: "",
            type: "bar",
            yAxisIndex: 1, //使两个柱状图重合的效果
            barWidth: "30%",
            data: [100, 100, 100, 100, 100, 100, 100],
            label: {
              show: false,
            },
            itemStyle: {
              color: "none",
              borderColor: "rgba(50, 229, 255, 1)",
              borderWidth: 2,
              borderRadius: 5, //圆角
            },
          },
        ],
      };
      option && myChart2.setOption(option);
    },
    showCenEchart2(res) {
      var myChart2 = this.$echarts.init(
        document.getElementById("centerEchart2")
      );
      var data1 = [];
      var data2 = [];
      for (var i in res) {
        data1.push(res[i].name);
        data2.push(res[i].value);
      }
      var option = {
        tooltip: {
          trigger: "axis",
          axisPointer: {
            type: "shadow",
          },
        },
        grid: {
          top: "5%",
          left: "5%",
          right: "5%",
          bottom: "5%",
          containLabel: true,
        },
        xAxis: {
          show: true,
          axisLabel: {
            formatter: "{value}",
            show: true,
          },
          splitLine: { show: false },
          axisLine: {
            show: true,
          },
        },
        yAxis: {
          type: "category",
          inverse: true, // 倒叙
          axisLabel: {
            color: "#FFF",
            fontSize: 20,
            formatter: (val) => {
              return `${val}`;
            },
          },
          axisLine: {
            show: false, // 轴线
          },
          axisTick: {
            show: false, // 刻度线
          },
          data: data1,
        },
        series: [
          {
            name: "数量",
            type: "bar",
            barWidth: 10,
            showBackground: true,
            barMaxWidth: 20,
            barMinWidth: 5,
            itemStyle: {
              borderRadius: [0, 10, 10, 0],
              color: new this.$echarts.graphic.LinearGradient(1, 0, 0, 0, [
                { offset: 0, color: "rgba(183, 75, 238)" },
                { offset: 1, color: "rgba(50, 229, 255, 1)" },
              ]),
              borderWidth: 1,
              borderColor: "black",
            },
            data: data2,
          },
        ],
      };

      option && myChart2.setOption(option);
    },
    showCenEchart1(res) {
      var myChart = this.$echarts.init(
        document.getElementById("centerEchart1")
      );
      var option = {
        tooltip: {
          trigger: "item",
          formatter: "{a} <br/>{b} : {c} ",
        },

        textStyle: {
          fontSize: 20, // 调节字体大小
        },
        label: {
          formatter: "{name|{b}}\n{time|{c} 家}",
          rich: {
            time: {
              fontSize: 14,
              edgeDistance: 60,
              top: 50,
              color: "#000",
            },
          },
          labelLine: {
            length: 0,
            length2: 0,
            maxSurfaceAngle: 80,
          },
        },
        series: [
          {
            name: "报警数量",
            type: "pie",
            radius: [10, 50],
            center: ["50%", "50%"],
            roseType: "area",
            itemStyle: {
              borderRadius: 5,
              fontSize: 10,
              normal: {
                color: function (params) {
                  var colorList = [
                    "#035899",
                    "#39C9FD",
                    "#FFD100",
                    "#04EB9F",
                    "#2993D1",
                    "#035AC8",
                  ];
                  return colorList[params.dataIndex];
                },
              },
            },
            data: res,
          },
        ],
      };
      option && myChart.setOption(option);
    },
  },
};
</script>

<style lang="less" scoped="scoped">
.box {
  width: 98%;
  height: 100%;

  .boxTop {
    height: 24%;
    width: 100%;

    .topdiv {
      width: 100%;
      height: calc(100% - 58px);
      margin-top: 10px;
      display: flex;
      justify-content: space-around;
      flex-flow: row wrap;
      padding-top: 5px;
      .topBox {
        width: 40%;
        height: 50%;
        background-image: url(../../../assets/image/Right/safe/矩形 3.png);
        background-size: 100% 100%;
        text-align: center;
        float: left;
        font-size: 24px;
        .topimg1 {
          background-image: url(../../../assets/image/Right/safe/图层 17 拷贝.png);
          background-size: 100% 100%;
        }
        .topimg2 {
          background-image: url(../../../assets/image/Right/safe/矩形 2 拷贝 3.png);
          background-size: 100% 100%;
        }
        .topimg3 {
          background-image: url(../../../assets/image/Right/safe/图层 17 拷贝 2.png);
          background-size: 100% 100%;
        }
        .topimg4 {
          background-image: url(../../../assets/image/Right/safe/图层 8 拷贝.png);
          background-size: 100% 100%;
        }
        .topLeft {
          width: 30%;
          height: 60%;
          margin-left: 10%;
          margin-right: 10%;
          margin-top: 10%;
          float: left;
        }
        .topright {
          width: 50%;
          height: 80%;
          margin-top: 10%;
          float: left;
          color: #fff;
          font-size: 20px;
          text-align: left;
          .topTitle {
            width: 100%;
            height: 50%;
            font-size: 40px;
            font-weight: 400;
            color: #d3d060;
            font-family: MytitileName;
          }
        }
      }
    }
  }
  .boxCenter {
    height: 38%;
    width: 98%;
    padding: 1%;
    .centerSpan1 {
      font-size: 22px;
      color: #fff;

      position: absolute;
      label {
        color: #31b6ea;
        font-size: 30px;
        font-weight: 400;
        font-family: MytitileName;
        margin-left: 1px;
        margin-right: 1px;
      }
    }
    .centerLeft {
      width: calc(50% - 5px);
      height: 100%;
      float: left;
      .centerTitle {
        width: 100%;
        height: 60px;
        background: linear-gradient(0deg, rgba(1, 52, 99, 0), #013463);
      }
      .centerEchart1 {
        width: 100%;
        height: calc(100% - 60px);
      }
    }
    .centerRight {
      width: calc(50% - 5px);
      height: 100%;
      float: right;
    }
  }
  .boxBottom {
    height: 38%;
    width: 100%;

    .botBox {
      width: 100%;
      height: calc(100% - 58px);
      margin-top: 10px;
      .bottomLeft {
        width: calc(50% - 5px);
        height: 100%;
        float: left;
      }
      .bottomRight {
        width: calc(50% - 5px);
        height: 100%;
        float: right;
      }
    }
  }
  .title {
    width: 100%;
    height: 38px;
    background-image: url(../../../assets/images/titleC.png);
    background-size: 100% 100%;
    font-family: MytitileName;
    font-size: 24px;
    display: flex;
    align-items: center;
    color: #98deff;
    letter-spacing: 3px;
    span {
      width: 80%;
      text-indent: 70px;
    }

    button {
      height: 80%;
      width: 20%;
      font-size: 22px;
      font-family: "microsoft yahei";
      background-color: transparent;
      color: #ffffff;
      border: solid 1px #04a7dc;
      background-color: #020919;
      border-radius: 10px;
    }
  }
}
</style>